// AboutPage.cpp : implementation file
//

#include "stdafx.h"
#include "ControlPanel.h"
#include "AboutPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutPage property page

IMPLEMENT_DYNCREATE(CAboutPage, CPropertyPage)

CAboutPage::CAboutPage() : CPropertyPage(CAboutPage::IDD)
{
	simpleHelp = FALSE;
	zopeDialog = NULL;
	//{{AFX_DATA_INIT(CAboutPage)
	//}}AFX_DATA_INIT
}

CAboutPage::~CAboutPage()
{
}

void CAboutPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutPage)
	DDX_Control(pDX, IDC_CONTROLLER_VERSION, m_ControllerVersion);
	DDX_Control(pDX, IDC_CONTROLLER, m_Controller);
	DDX_Control(pDX, IDC_DATABASE, m_Database);
	DDX_Control(pDX, IDC_DATABASE_SIZE, m_DatabaseSize);
	DDX_Control(pDX, IDC_ZOPE, m_Zope);
	DDX_Control(pDX, IDC_INTERPRETER, m_Interpreter);
	DDX_Control(pDX, IDC_ZOPE_VERSION, m_ZopeVersion);
	DDX_Control(pDX, IDC_INTERPRETER_VERSION, m_InterpreterVersion);
	DDX_Control(pDX, IDC_HELPTEXT, m_HelpText);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAboutPage, CPropertyPage)
	//{{AFX_MSG_MAP(CAboutPage)
	ON_WM_DESTROY()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAboutPage message handlers


/* These two functions PrepareMask() and DrawTransparent() were
   taken from Raja Segar's excellent example available at

	http://www.codeproject.com/bitmap/transbitmapmask.asp

   Many thanks indeed!
*/

void CAboutPage::PrepareMask( CBitmap* pBmpSource,
							  CBitmap* pBmpMask,
							  COLORREF clrpTransColor, // Pass null if unknown
							  int iTransPixelX,      // = 0
							  int iTransPixelY       // = 0
							)
{
   BITMAP bm;

   // Get the dimensions of the source bitmap
   pBmpSource->GetObject(sizeof(BITMAP), &bm);

   // Create the mask bitmap
   pBmpMask->DeleteObject();
   pBmpMask->CreateBitmap( bm.bmWidth, bm.bmHeight, 1, 1, NULL);

   // We will need two DCs to work with. One to hold the Image
   // (the source), and one to hold the mask (destination).
   // When blitting onto a monochrome bitmap from a color, pixels
   // in the source color bitmap that are equal to the background
   // color are blitted as white. All the remaining pixels are
   // blitted as black.

   CDC hdcSrc, hdcDst;

   hdcSrc.CreateCompatibleDC(NULL);
   hdcDst.CreateCompatibleDC(NULL);

   // Load the bitmaps into memory DC
   CBitmap* hbmSrcT = (CBitmap*) hdcSrc.SelectObject(pBmpSource);
   CBitmap* hbmDstT = (CBitmap*) hdcDst.SelectObject(pBmpMask);

   // Dynamically get the transparent color
   COLORREF clrTrans;
   if (clrpTransColor == NULL)
   {
      // User did not specify trans color so get it from bmp
      clrTrans = hdcSrc.GetPixel(iTransPixelX, iTransPixelY);
   }
   else
   {
      clrTrans = clrpTransColor;
   }


   // Change the background to trans color
   COLORREF clrSaveBk  = hdcSrc.SetBkColor(clrTrans);

   // This call sets up the mask bitmap.
   hdcDst.BitBlt(0,0,bm.bmWidth, bm.bmHeight, &hdcSrc,0,0,SRCCOPY);

   // Now, we need to paint onto the original image, making
   // sure that the "transparent" area is set to black. What
   // we do is AND the monochrome image onto the color Image
   // first. When blitting from mono to color, the monochrome
   // pixel is first transformed as follows:
   // if  1 (black) it is mapped to the color set by SetTextColor().
   // if  0 (white) is is mapped to the color set by SetBkColor().
   // Only then is the raster operation performed.

   COLORREF clrSaveDstText = hdcSrc.SetTextColor(RGB(255,255,255));
   hdcSrc.SetBkColor(RGB(0,0,0));

   hdcSrc.BitBlt(0,0,bm.bmWidth, bm.bmHeight, &hdcDst,0,0,SRCAND);

   // Clean up by deselecting any objects, and delete the
   // DC's.
   hdcDst.SetTextColor(clrSaveDstText);

   hdcSrc.SetBkColor(clrSaveBk);
   hdcSrc.SelectObject(hbmSrcT);
   hdcDst.SelectObject(hbmDstT);

   hdcSrc.DeleteDC();
   hdcDst.DeleteDC();
}



void CAboutPage::DrawTransparentBitmap(CDC* pDC,
									   int xStart,  int yStart,
									   int wWidth,  int wHeight,
									   CDC* pTmpDC,
									   int xSource, // = 0
									   int ySource  // = 0
									  )
{

   // We are going to paint the two DDB's in sequence to the destination.
   // 1st the monochrome bitmap will be blitted using an AND operation to
   // cut a hole in the destination. The color image will then be ORed
   // with the destination, filling it into the hole, but leaving the
   // surrounding area untouched.

   CDC hdcMem;
   hdcMem.CreateCompatibleDC(NULL);

   CBitmap* hbmT = hdcMem.SelectObject(&m_bmpMask);

   pDC->BitBlt( xStart, yStart, wWidth, wHeight, &hdcMem,
                xSource, ySource, SRCAND);

   // Also note the use of SRCPAINT rather than SRCCOPY.

   pDC->BitBlt(xStart, yStart, wWidth, wHeight, pTmpDC,
               xSource, ySource,SRCPAINT);

   // Now, clean up.
   hdcMem.SelectObject(hbmT);
   hdcMem.DeleteDC();
}

void CAboutPage::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// Get the rectangle for where to draw the logo
	CRect rc;
	CWnd *placeholder = GetDlgItem(IDC_LOGO_PLACEHOLDER);
	placeholder->GetWindowRect(rc);
	ScreenToClient(rc);
	
	// Get the width & height of bitmap
	BITMAP bmp;
	m_bmpLogo.GetBitmap(&bmp);


	CDC dcMem;                  // memory device context
	dcMem.CreateCompatibleDC(&dc);

	// Select the bmp into the tmp memory DC
	CBitmap* pOldBmp = (CBitmap*) dcMem.SelectObject(&m_bmpLogo);

	DrawTransparentBitmap( &dc,           // The destination DC.
						 rc.left,         // Where to draw
						 rc.top,
						 bmp.bmWidth,     // Width & Height
						 bmp.bmHeight,
						 &dcMem,        // the DC holding the bmp
						 0, // x & y pos in master bmp
						 0);

	dcMem.SelectObject(pOldBmp);

	
	
}

BOOL CAboutPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// Load the logo bitmap from a resource
	m_bmpLogo.LoadBitmap(IDB_LOGO);

	// Create the transparency mask needed for the Zope logo
	PrepareMask( &m_bmpLogo, &m_bmpMask, NULL);	
	
	
	// Create the bold font
	fontBold = new CFont();
	fontBold->CreateFont(-11, 0, 0, 0, FW_BOLD,
						 FALSE, FALSE, FALSE,
						 ANSI_CHARSET,
						 OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
						 DEFAULT_QUALITY, 
						 DEFAULT_PITCH | FF_DONTCARE,
						 "MS Shell Dlg");

	// Apply bold font to the two version labels
	m_ControllerVersion.SetFont(fontBold);
	m_InterpreterVersion.SetFont(fontBold);
	m_ZopeVersion.SetFont(fontBold);
	m_DatabaseSize.SetFont(fontBold);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAboutPage::OnDestroy() 
{
	// Free bitmap resources
	m_bmpLogo.DeleteObject();
	m_bmpMask.DeleteObject();
	
	// And the font!
	delete fontBold;

	CPropertyPage::OnDestroy();
}


BOOL CAboutPage::OnSetActive() 
{
	if (simpleHelp)
	{
		// This is where the about tab is the only
		// one showing (i.e. there are no configurations)
		m_HelpText.SetWindowText(CString((LPCSTR) IDS_DIALOG_NO_CONFIGURATIONS));

		m_Controller.ShowWindow(SW_HIDE);
		m_Zope.ShowWindow(SW_HIDE);
		m_Interpreter.ShowWindow(SW_HIDE);
		m_Database.ShowWindow(SW_HIDE);
		m_ControllerVersion.ShowWindow(SW_HIDE);
		m_ZopeVersion.ShowWindow(SW_HIDE);
		m_InterpreterVersion.ShowWindow(SW_HIDE);
		m_DatabaseSize.ShowWindow(SW_HIDE);

	}
	else
	{
		// Show current config versions
		m_HelpText.SetWindowText(CString((LPCSTR) IDS_DIALOG_ABOUT_MSG));
		m_ZopeVersion.SetWindowText(CString((LPCSTR) IDS_VERSION_STRING));

		m_Controller.ShowWindow(SW_SHOW);
		m_Zope.ShowWindow(SW_SHOW);
		m_Interpreter.ShowWindow(SW_SHOW);
		m_Database.ShowWindow(SW_SHOW);
		m_ControllerVersion.ShowWindow(SW_SHOW);
		m_ZopeVersion.ShowWindow(SW_SHOW);
		m_InterpreterVersion.ShowWindow(SW_SHOW);
		m_DatabaseSize.ShowWindow(SW_SHOW);

		// Get config
		ASSERT(zopeDialog);
		ZopeService *currentService = zopeDialog->currentService;
		
		if (currentService)
		{
			// Retrieve zope version
			// This is in INSTANCE_HOME\lib\python\version.txt

			CString version;
			CString filename = currentService->m_SoftwareHome;
			if (filename.Right(1) != "\\")
				filename += "\\";
			filename += "lib\\python\\version.txt";

			FILE *fZopeVersion = fopen(filename, "rt");
			if (!fZopeVersion)
				version = "Zope not found";
			else
			{
				// Note arbitrary version length of 256
				fgets(version.GetBuffer(256), 256, fZopeVersion);
				version.ReleaseBuffer();
				fclose(fZopeVersion);
			}

			// Put Zope's extended version on the next line
			int split = version.Find('(');
			if (split != -1)
			{
				version = version.Left(split)
							+ "\n" + version.Mid(split);
			}

			m_ZopeVersion.SetWindowText(version);

			/////////////////////////////////////////////////////////
			// Retrieve python (interpreter) version
			// This is done by running python.exe -V and getting stderr

			CString interpreterFilename = "\"" + currentService->m_Interpreter + "\" -V";
			
			// Security attributes enable handle to be inherited
			SECURITY_ATTRIBUTES sa;
			sa.nLength = sizeof(sa);
			sa.lpSecurityDescriptor = NULL;
			sa.bInheritHandle = TRUE;
			
			HANDLE hErrorWrite;
			HANDLE hErrorRead, hErrorReadTmp;
			
			// Create anonymous pipe to retrieve stderr
			// of python
			CreatePipe(&hErrorReadTmp, &hErrorWrite, &sa, 0);
			

			// Create new error read handle to prevent child
			// inheriting properties and creating non-closeable
			// handles
			DuplicateHandle(GetCurrentProcess(), hErrorReadTmp,
								 GetCurrentProcess(),
								 &hErrorRead,	// Address of new handle
								 0, FALSE,		// Un-inheritable
								 DUPLICATE_SAME_ACCESS);

			// Close inheritable copies of the handles
			// you do not want to be inherited
			CloseHandle(hErrorReadTmp);

				
			// Process information for python.exe
			// Note only stderr is redirected.
			PROCESS_INFORMATION processInfo;
			STARTUPINFO startupInfo;
			memset(&startupInfo, 0, sizeof(startupInfo));
			startupInfo.cb = sizeof(startupInfo);
			startupInfo.hStdError = hErrorWrite;
			startupInfo.hStdInput = GetStdHandle(STD_INPUT_HANDLE);
			startupInfo.hStdOutput = GetStdHandle(STD_OUTPUT_HANDLE);
			startupInfo.wShowWindow = SW_HIDE;
			startupInfo.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;

			BOOL result = CreateProcess(NULL,
										interpreterFilename.GetBuffer(interpreterFilename.GetLength()),
										NULL,
										NULL,
										TRUE,	// Inherit handles
										NULL,	// Create flags
										NULL,
										NULL,
										&startupInfo,
										&processInfo);
			interpreterFilename.ReleaseBuffer();

			
			
			if (!result)
			{
				version = "Interpreter not found";
			}
			else
			{
				// Close unnecessary handle to allow thread
				// to exit
				CloseHandle(processInfo.hThread);

				// Close output handle to allow
				// pipe to close
				CloseHandle(hErrorWrite);
				
				DWORD size = 255; // Arbitrary
				
				// Read the output
				ReadFile(hErrorRead, version.GetBuffer(size), size, &size, NULL);
				version.ReleaseBuffer();
				version = version.Left(size);
			}

			CloseHandle(hErrorRead);
			
			m_InterpreterVersion.SetWindowText(version);

			/////////////////////////////////////////////////////////////
			// Database size
		
			CString strDatabase = CZopeDialog::AddTrailingSlash(currentService->m_ClientHome) + "data.fs";
			CString databaseSize;
			CFileStatus databaseStatus;

			if (CFile::GetStatus(strDatabase, databaseStatus))
			{
				if (databaseStatus.m_size < 1024)
					databaseSize.Format((LPCSTR) "%u Bytes", databaseStatus.m_size);
				else if (databaseStatus.m_size < 1048576)
					databaseSize.Format((LPCSTR) "%.1f KB", (float) databaseStatus.m_size / 1024);
				else
					databaseSize.Format((LPCSTR) "%.2f MB", (float) databaseStatus.m_size / 1048576);
			}
			else
				databaseSize = "Not found";

			m_DatabaseSize.SetWindowText(databaseSize);


		}
		else
		{
			m_ZopeVersion.SetWindowText("");
			m_InterpreterVersion.SetWindowText("");
			m_DatabaseSize.SetWindowText("");
		}
	}

	return CPropertyPage::OnSetActive();
}

