// AddManager.cpp : implementation file
//

#include "stdafx.h"
#include "ControlPanel.h"
#include "AddManager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddManager property page

IMPLEMENT_DYNCREATE(CAddManager, CWizardPage)

CAddManager::CAddManager() : CWizardPage(CAddManager::IDD)
{
	//{{AFX_DATA_INIT(CAddManager)
	m_Password1 = _T("");
	m_Password2 = _T("");
	m_Username = _T("");
	//}}AFX_DATA_INIT
}

CAddManager::~CAddManager()
{
}

void CAddManager::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddManager)
	DDX_Text(pDX, IDC_PASSWORD1, m_Password1);
	DDX_Text(pDX, IDC_PASSWORD2, m_Password2);
	DDX_Text(pDX, IDC_USERNAME, m_Username);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddManager, CPropertyPage)
	//{{AFX_MSG_MAP(CAddManager)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddManager message handlers

void CAddManager::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	Paint(dc);
	
	// Do not call CPropertyPage::OnPaint() for painting messages
}

BOOL CAddManager::OnSetActive() 
{
	SetButtons(PSWIZB_NEXT | PSWIZB_BACK);

	return CPropertyPage::OnSetActive();
}

LRESULT CAddManager::OnWizardNext() 
{
	UpdateData(TRUE);

	// Validate user data
	if (m_Username.GetLength() == 0
		|| m_Password1.GetLength() == 0)
	{
		MessageBox("You must enter both a username and a password for the initial manager user.", theApp.m_DialogCaption, MB_ICONEXCLAMATION);
		return -1;
	}

	else if (m_Password1 != m_Password2)
	{
		MessageBox("Passwords do not match.  Please enter the same password in both fields to confirm your choice.", theApp.m_DialogCaption, MB_ICONEXCLAMATION);
		return -1;
	}

	return CPropertyPage::OnWizardNext();
}
