// AddName.cpp : implementation file
//

#include "stdafx.h"
#include "ControlPanel.h"
#include "AddName.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddName property page

IMPLEMENT_DYNCREATE(CAddName, CWizardPage)

CAddName::CAddName() : CWizardPage(CAddName::IDD)
{
	//{{AFX_DATA_INIT(CAddName)
	m_Name = _T("");
	//}}AFX_DATA_INIT
}

CAddName::~CAddName()
{
}

void CAddName::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddName)
	DDX_Text(pDX, IDC_NAME, m_Name);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddName, CPropertyPage)
	//{{AFX_MSG_MAP(CAddName)
	ON_WM_PAINT()
	ON_EN_CHANGE(IDC_NAME, OnChangeName)
	//}}AFX_MSG_MAP
	ON_MESSAGE(PSM_QUERYSIBLINGS, OnQuerySibling)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddName message handlers

void CAddName::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	Paint(dc);
	
	// Do not call CPropertyPage::OnPaint() for painting messages
}


BOOL CAddName::OnSetActive() 
{
	// Set button state
	OnChangeName();
	
	
	return CPropertyPage::OnSetActive();
}

void CAddName::OnChangeName() 
{
	// Enable Next button	
	UpdateData(TRUE);
	if (m_Name.GetLength() > 0)
		SetButtons(PSWIZB_NEXT);
	else
		SetButtons(NULL);
}

LRESULT CAddName::OnWizardNext() 
{
	UpdateData(TRUE);

	m_Name.TrimLeft(' ');
	m_Name.TrimRight(' ');
	
	// Cycle through the list of services.. make sure there
	// are no name clashes
	if (!zopeDialog->m_SetupWizard)
	{
		CComboBox *configList = &(zopeDialog->m_ConfigurationList);
		
		for (int i = 0; i < configList->GetCount(); i++)
		{
			CString buf;
			configList->GetLBText(i, buf);
			if (buf.CompareNoCase(m_Name) == 0)
			{
				MessageBox("There is already a service with this name.  Please enter another.", theApp.m_DialogCaption, MB_ICONEXCLAMATION);
				return -1;
			}
		}
	}
	
	return CPropertyPage::OnWizardNext();
}

LRESULT CAddName::OnQuerySibling(WPARAM wParam, LPARAM lParam)
{
	if (lParam == 1) // Request for service name
		return (LRESULT) (LPCSTR) m_Name;
	else
		return 0;	// Someone else's problem

}