// AddSource.cpp : implementation file
//

#include "stdafx.h"
#include "ControlPanel.h"
#include "AddSource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddSource property page

IMPLEMENT_DYNCREATE(CAddSource, CWizardPage)

CAddSource::CAddSource() : CWizardPage(CAddSource::IDD)
{
	//{{AFX_DATA_INIT(CAddSource)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CAddSource::~CAddSource()
{
}

void CAddSource::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddSource)
	DDX_Control(pDX, IDC_DONTCOPY_CONFIGURATIONS, m_DontCopyConfigurations);
	DDX_Control(pDX, IDC_COPY_CONFIGURATIONS, m_CopyConfigurations);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddSource, CPropertyPage)
	//{{AFX_MSG_MAP(CAddSource)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_COPY, OnCopy)
	ON_BN_CLICKED(IDC_CREATENEW, OnCreatenew)
	ON_BN_CLICKED(IDC_DONTCOPY, OnDontcopy)
	ON_BN_CLICKED(IDC_ATTACH, OnAttach)
	//}}AFX_MSG_MAP
	ON_MESSAGE(PSM_QUERYSIBLINGS, OnQuerySibling)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddSource message handlers

void CAddSource::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	Paint(dc);	
	
}

LRESULT CAddSource::OnWizardNext() 
{
	if (m_SourceType == Copy)
	{
		m_BaseInstance = (ZopeService *) m_CopyConfigurations.GetItemDataPtr(m_CopyConfigurations.GetCurSel());
		return IDD_ADD_INSTANCEDIR;
	}
	else if (m_SourceType == DontCopy)
	{
		m_BaseInstance = (ZopeService *) m_DontCopyConfigurations.GetItemDataPtr(m_DontCopyConfigurations.GetCurSel());
		return IDD_ADD_FINISH;
	}
	else if (m_SourceType == CreateNew)
	{
		m_BaseInstance = NULL;
		return IDD_ADD_INSTANCEDIR;
	}
	else if (m_SourceType == AttachExisting)
	{
		m_BaseInstance = NULL;
		return IDD_ADD_INSTANCEDIR;
	}

	
	ASSERT(FALSE); // shouldn't get here

	return CPropertyPage::OnWizardNext();
}

void CAddSource::OnCopy() 
{
	EnableControls(TRUE, FALSE);
	m_SourceType = Copy;
}

void CAddSource::OnCreatenew() 
{
	EnableControls(FALSE, FALSE);
	m_SourceType = CreateNew;
}

void CAddSource::OnDontcopy() 
{
	EnableControls(FALSE, TRUE);
	m_SourceType = DontCopy;
}

void CAddSource::OnAttach() 
{
	EnableControls(FALSE, FALSE);
	m_SourceType = AttachExisting;
	
}

BOOL CAddSource::OnInitDialog() 
{
	CWizardPage::OnInitDialog();
	
	if (!zopeDialog->m_SetupWizard)
	{
		// Fill up the configurations lists
		CZopeDialog *zopeDialog = (CZopeDialog *) GetParent()->GetOwner();
		ASSERT(zopeDialog);

		CComboBox *configList = &(zopeDialog->m_ConfigurationList);
		
		for (int i = 0; i < configList->GetCount(); i++)
		{
			CString buf;
			configList->GetLBText(i, buf);
			int index = m_CopyConfigurations.AddString(buf);
			m_CopyConfigurations.SetItemDataPtr(index, configList->GetItemDataPtr(i));
			index = m_DontCopyConfigurations.AddString(buf);
			m_DontCopyConfigurations.SetItemDataPtr(index, configList->GetItemDataPtr(i));
		}

		// Default selections
		((CButton *) GetDlgItem(IDC_CREATENEW))->SetCheck(1);
		m_CopyConfigurations.SetCurSel(0);
		m_DontCopyConfigurations.SetCurSel(0);
		OnCreatenew();

		// Disable lists if nothing in them
		if (configList->GetCount() == 0)
		{
			GetDlgItem(IDC_COPY)->EnableWindow(FALSE);
			GetDlgItem(IDC_DONTCOPY)->EnableWindow(FALSE);
			m_CopyConfigurations.EnableWindow(FALSE);
			m_DontCopyConfigurations.EnableWindow(FALSE);
		}
	}
	else
	{
		// Running as Setup Wizard
		// Hide invalid choices
		GetDlgItem(IDC_COPY)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_DONTCOPY)->ShowWindow(SW_HIDE);
		m_CopyConfigurations.ShowWindow(SW_HIDE);
		m_DontCopyConfigurations.ShowWindow(SW_HIDE);
	
		// Select default
		m_SourceType = CreateNew;
		((CButton *) GetDlgItem(IDC_CREATENEW))->SetCheck(1);

		// Change text slightly
		GetDlgItem(IDC_ATTACH)->SetWindowText("I already have a previous installation of Zope on this computer.  Create a configuration so I can manage this existing instance.");

	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
	
}

void CAddSource::EnableControls(BOOL copy, BOOL dontCopy)
{
	m_CopyConfigurations.EnableWindow(copy);
	m_DontCopyConfigurations.EnableWindow(dontCopy);
}

afx_msg LRESULT CAddSource::OnQuerySibling(WPARAM wParam, LPARAM lParam)
{
	if (lParam == 0) // Request for source type
		return (LRESULT) m_SourceType;
	else
		return 0;	// Someone else's problem
}



BOOL CAddSource::OnSetActive() 
{
	SetButtons(PSWIZB_BACK | PSWIZB_NEXT);
	
	return CPropertyPage::OnSetActive();
}
