// AdvancedDialog.cpp : implementation file
//

#include "stdafx.h"
#include "ControlPanel.h"
#include "AdvancedDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAdvancedDialog dialog


CAdvancedDialog::CAdvancedDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CAdvancedDialog::IDD, pParent)
{
	m_DaemonNT = FALSE;
	m_NTDisabled = FALSE;
	//{{AFX_DATA_INIT(CAdvancedDialog)
	m_Path95 = _T("");
	m_PathNT = _T("");
	m_Interpreter = _T("");
	m_PythonHome = _T("");
	m_SoftwareHome = _T("");
	m_StartupScript = _T("");
	//}}AFX_DATA_INIT
}


void CAdvancedDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdvancedDialog)
	DDX_Control(pDX, IDC_STARTUPSCRIPT, m_editStartupScript);
	DDX_Control(pDX, IDC_SOFTWAREHOME, m_editSoftwareHome);
	DDX_Control(pDX, IDC_PYTHONHOME, m_editPythonHome);
	DDX_Control(pDX, IDC_INTERPRETER, m_editInterpreter);
	DDX_Control(pDX, IDC_SERVICE_DAEMON_PATH_NT, m_editPathNT);
	DDX_Control(pDX, IDC_SERVICE_DAEMON_PATH_95, m_editPath95);
	DDX_Control(pDX, IDC_BROWSE_DAEMON_NT, m_BrowseNT);
	DDX_Control(pDX, IDC_BROWSE_DAEMON_95, m_Browse95);
	DDX_Text(pDX, IDC_SERVICE_DAEMON_PATH_95, m_Path95);
	DDX_Text(pDX, IDC_SERVICE_DAEMON_PATH_NT, m_PathNT);
	DDX_Text(pDX, IDC_INTERPRETER, m_Interpreter);
	DDX_Text(pDX, IDC_PYTHONHOME, m_PythonHome);
	DDX_Text(pDX, IDC_SOFTWAREHOME, m_SoftwareHome);
	DDX_Text(pDX, IDC_STARTUPSCRIPT, m_StartupScript);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAdvancedDialog, CDialog)
	//{{AFX_MSG_MAP(CAdvancedDialog)
	ON_BN_CLICKED(IDC_BROWSE_DAEMON_95, OnBrowseDaemon95)
	ON_BN_CLICKED(IDC_BROWSE_DAEMON_NT, OnBrowseDaemonNt)
	ON_BN_CLICKED(IDC_SERVICE_DAEMON_95, OnServiceDaemon95)
	ON_BN_CLICKED(IDC_SERVICE_DAEMON_NT, OnServiceDaemonNt)
	ON_BN_CLICKED(IDC_BROWSE_GINTERPRETER, OnBrowseInterpreter)
	ON_BN_CLICKED(IDC_BROWSE_GPYTHONHOME, OnBrowsePythonhome)
	ON_BN_CLICKED(IDC_BROWSE_GSOFTWAREHOME, OnBrowseSoftwarehome)
	ON_BN_CLICKED(IDC_BROWSE_GSTARTUPSCRIPT, OnBrowseStartupscript)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdvancedDialog message handlers

void CAdvancedDialog::BrowseFile(CEdit *edit, CString defaultExtension, CString filter)
{
	CString strCurrent;
	edit->GetWindowText(strCurrent);
	
	CFileDialog dlg(TRUE, defaultExtension, strCurrent, OFN_HIDEREADONLY, filter, this); 
	dlg.DoModal();
	
	edit->SetWindowText(dlg.GetPathName());
}

void CAdvancedDialog::BrowsePath(CEdit *edit, CString prompt)
{
	char path[MAX_PATH];

	BROWSEINFO bi;
	ZeroMemory(&bi, sizeof(bi));
	bi.hwndOwner = m_hWnd;
	bi.lpszTitle = prompt;

	edit->GetWindowText(path, MAX_PATH);

	ITEMIDLIST *idList;
	idList = SHBrowseForFolder(&bi);
	if (idList)
	{

        if ( SHGetPathFromIDList ( idList, path ) )
        {
			edit->SetWindowText(path);
        }


		// Free mem
		IMalloc *imalloc = 0;
		if ( SUCCEEDED( SHGetMalloc ( &imalloc )) )
		{
			imalloc->Free(idList);
			imalloc->Release();
		}
	}
}

void CAdvancedDialog::OnBrowseDaemon95() 
{
	BrowseFile(&m_editPath95, "exe", "95 Service Daemon (ZopeService95.exe)|zopeservice95.exe|All Executables (*.exe)|*.exe|All Files (*.*)|*.*||");	
}

void CAdvancedDialog::OnBrowseDaemonNt() 
{
	BrowseFile(&m_editPathNT, "exe", "NT Service Daemon (ZopeServiceNT.exe)|zopeserviceNT.exe|All Executables (*.exe)|*.exe|All Files (*.*)|*.*||"); 
}

void CAdvancedDialog::OnServiceDaemon95() 
{
	// Disable/Enable appropriate controls
	SetDaemonNT(FALSE);
	
}

void CAdvancedDialog::OnServiceDaemonNt() 
{
	// Disable/Enable appropriate controls
	SetDaemonNT(TRUE);
	
}

void CAdvancedDialog::SetDaemonNT(BOOL asNT)
{
	// SetDaemonNT(TRUE) for NT
	// SetDaemonNT(FALSE) for 95

	m_editPath95.EnableWindow(!asNT);
	m_editPathNT.EnableWindow(asNT);
	m_Browse95.EnableWindow(!asNT);
	m_BrowseNT.EnableWindow(asNT);

	CButton *radio;
	if (asNT)
		radio = (CButton *) GetDlgItem(IDC_SERVICE_DAEMON_NT);
	else
		radio = (CButton *) GetDlgItem(IDC_SERVICE_DAEMON_95);

	ASSERT(radio);
	radio->SetCheck(1);

	m_DaemonNT = asNT;
}


BOOL CAdvancedDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if (m_NTDisabled)
	{
		// Obviously the NT daemon is not available
		// as an option on 95/98 systems

		SetDaemonNT(FALSE);

		CWnd *radio = GetDlgItem(IDC_SERVICE_DAEMON_NT);
		radio->EnableWindow(FALSE);
	}
	
	SetDaemonNT(m_DaemonNT);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAdvancedDialog::OnOK() 
{
	if (MessageBox("Please note that any changes you have made will not take effect until you restart each service.", theApp.m_DialogCaption, MB_ICONINFORMATION | MB_OKCANCEL) == IDOK)
		CDialog::OnOK();
}

void CAdvancedDialog::OnBrowseInterpreter() 
{
	BrowseFile(&m_editInterpreter, "exe", "Python (python.exe)|python.exe|All Executables (*.exe)|*.exe|All Files (*.*)|*.*||");	
}

void CAdvancedDialog::OnBrowsePythonhome() 
{
	BrowsePath(&m_editPythonHome, "Select the Python Home directory:");
	
}

void CAdvancedDialog::OnBrowseSoftwarehome() 
{
	BrowsePath(&m_editSoftwareHome, "Select the Software Home directory:");
	
}

void CAdvancedDialog::OnBrowseStartupscript() 
{
	BrowseFile(&m_editStartupScript, "py", "Python Scripts (*.py; *.pyc)|*.py;*.pyc|All Files (*.*)|*.*||");
}
