// AdvancedInstance.cpp : implementation file
//

#include "stdafx.h"
#include "ControlPanel.h"
#include "AdvancedInstance.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAdvancedInstance dialog


CAdvancedInstance::CAdvancedInstance(CWnd* pParent /*=NULL*/)
	: CDialog(CAdvancedInstance::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAdvancedInstance)
	m_Clienthome = _T("");
	m_Interpreter = _T("");
	m_Pythonhome = _T("");
	m_Override = FALSE;
	m_Softwarehome = _T("");
	m_Startupscript = _T("");
	//}}AFX_DATA_INIT
}


void CAdvancedInstance::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdvancedInstance)
	DDX_Control(pDX, IDC_STARTUPSCRIPT, m_editStartupscript);
	DDX_Control(pDX, IDC_SOFTWAREHOME, m_editSoftwarehome);
	DDX_Control(pDX, IDC_PYTHONHOME, m_editPythonhome);
	DDX_Control(pDX, IDC_INTERPRETER, m_editInterpreter);
	DDX_Control(pDX, IDC_CLIENTHOME, m_editClienthome);
	DDX_Control(pDX, IDC_BROWSE_STARTUPSCRIPT, m_BrowseStartupscript);
	DDX_Control(pDX, IDC_BROWSE_SOFTWAREHOME, m_BrowseSoftwarehome);
	DDX_Control(pDX, IDC_BROWSE_PYTHONHOME, m_BrowsePythonhome);
	DDX_Control(pDX, IDC_BROWSE_INTERPRETER, m_BrowseInterpreter);
	DDX_Control(pDX, IDC_BROWSE_CLIENT, m_BrowseClient);
	DDX_Text(pDX, IDC_CLIENTHOME, m_Clienthome);
	DDX_Text(pDX, IDC_INTERPRETER, m_Interpreter);
	DDX_Text(pDX, IDC_PYTHONHOME, m_Pythonhome);
	DDX_Check(pDX, IDC_OVERRIDE, m_Override);
	DDX_Text(pDX, IDC_SOFTWAREHOME, m_Softwarehome);
	DDX_Text(pDX, IDC_STARTUPSCRIPT, m_Startupscript);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAdvancedInstance, CDialog)
	//{{AFX_MSG_MAP(CAdvancedInstance)
	ON_BN_CLICKED(IDC_BROWSE_CLIENT, OnBrowseClient)
	ON_BN_CLICKED(IDC_BROWSE_INTERPRETER, OnBrowseInterpreter)
	ON_BN_CLICKED(IDC_BROWSE_PYTHONHOME, OnBrowsePythonhome)
	ON_BN_CLICKED(IDC_BROWSE_SOFTWAREHOME, OnBrowseSoftwarehome)
	ON_BN_CLICKED(IDC_BROWSE_STARTUPSCRIPT, OnBrowseStartupscript)
	ON_BN_CLICKED(IDC_OVERRIDE, OnOverride)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdvancedInstance message handlers

void CAdvancedInstance::BrowseFile(CEdit *edit, CString defaultExtension, CString filter)
{
	CString strCurrent;
	edit->GetWindowText(strCurrent);
	
	CFileDialog dlg(TRUE, defaultExtension, strCurrent, OFN_HIDEREADONLY, filter, this); 
	dlg.DoModal();
	
	edit->SetWindowText(dlg.GetPathName());
}

void CAdvancedInstance::BrowsePath(CEdit *edit, CString prompt)
{
	char path[MAX_PATH];

	BROWSEINFO bi;
	ZeroMemory(&bi, sizeof(bi));
	bi.hwndOwner = m_hWnd;
	bi.lpszTitle = prompt;

	edit->GetWindowText(path, MAX_PATH);

	ITEMIDLIST *idList;
	idList = SHBrowseForFolder(&bi);
	if (idList)
	{

        if ( SHGetPathFromIDList ( idList, path ) )
        {
			edit->SetWindowText(path);
        }


		// Free mem
		IMalloc *imalloc = 0;
		if ( SUCCEEDED( SHGetMalloc ( &imalloc )) )
		{
			imalloc->Free(idList);
			imalloc->Release();
		}
	}
}



void CAdvancedInstance::OnBrowseClient() 
{
	BrowsePath(&m_editClienthome, CString((LPCSTR) IDS_PROMPT_BROWSE_CLIENT_HOME));
}

void CAdvancedInstance::OnBrowseInterpreter() 
{
	BrowseFile(&m_editInterpreter, "exe", "Python|python.exe|All Executables (*.exe)|*.exe|All Files (*.*)|*.*||"); 
}

void CAdvancedInstance::OnBrowsePythonhome() 
{
	BrowsePath(&m_editPythonhome, CString((LPCSTR) IDS_PROMPT_BROWSE_PYTHON_HOME));	
}

void CAdvancedInstance::OnBrowseSoftwarehome() 
{
	BrowsePath(&m_editSoftwarehome, CString((LPCSTR) IDS_PROMPT_BROWSE_SOFTWARE_HOME));	
}

void CAdvancedInstance::OnBrowseStartupscript() 
{
	BrowseFile(&m_editStartupscript, "py", "Python Scripts (*.py; *.pyc)|*.py; *.pyc|All Files (*.*)|*.*||"); 
}

void CAdvancedInstance::OnOverride() 
{
	// Enable / disable controls
	m_Override = ((CButton *) GetDlgItem(IDC_OVERRIDE))->GetCheck();

	EnableWindows(m_Override);
}

void CAdvancedInstance::EnableWindows(BOOL enabled)
{
	m_editInterpreter.EnableWindow(enabled);
	m_editPythonhome.EnableWindow(enabled);
	m_editSoftwarehome.EnableWindow(enabled);
	m_editStartupscript.EnableWindow(enabled);
}

BOOL CAdvancedInstance::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Before we go modal we need to enable/disable the right controls
	EnableWindows(m_Override);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
