// ControlPanel.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <cpl.h>
#include "ControlPanel.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CControlPanelApp

BEGIN_MESSAGE_MAP(CControlPanelApp, CWinApp)
	//{{AFX_MSG_MAP(CControlPanelApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CControlPanelApp construction

CControlPanelApp::CControlPanelApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CControlPanelApp object

CControlPanelApp theApp;

/////////////////////////////////////////////////////////////////////////////
// The Control Panel handler
LONG APIENTRY CPlApplet(HWND hwndCPl, UINT uMsg, LONG lParam1, LONG lParam2)
{
	// Required for dynamic MFC binding
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	// Get name of CPL ("Zope Configuration")
	theApp.m_DialogCaption.LoadString(IDS_DIALOG_CAPTION);

	LPCPLINFO info;

	switch (uMsg)
	{
		case CPL_INIT:
			// Initialize
			// Get the application reg key from resource
			theApp.regKey.LoadString(IDS_REGKEY);
			
			// Extrapolate services key
			theApp.servicesKey = theApp.regKey;
			theApp.servicesKey += (theApp.servicesKey.Right(1) == "\\" ? "" : "\\");
			theApp.servicesKey += "Services";
			return 1;

		case CPL_GETCOUNT:
			// Number of applets
			return 1;

		case CPL_INQUIRE:
			// We only have one applet, so return
			// its info
			info = (LPCPLINFO) lParam2;
			info->idIcon = IDI_ICON;
			info->idName = IDS_CPLNAME;
			info->idInfo = IDS_CPLDESCRIPTION;
			return 0;

		case CPL_DBLCLK:
		{
			// Activate the applet
			theApp.dlg.DoModal();
			return TRUE;
		}
		case CPL_STARTWPARMS:
		{
			if (_stricmp((LPCSTR) lParam2, "SetupWizard") == 0)
			{
				// Launch the tail end of the setup wizard
				theApp.dlg.DoSetupWizard();

			} else
			{
				// Normal execution
				theApp.dlg.DoModal();
			}
			return TRUE;
		}
		case CPL_STOP:
			return 0;
		case CPL_EXIT:
			return 0;
	}
	return 0;
}



BOOL CControlPanelApp::InitInstance() 
{
	// Initialize the Zope Service 95 messages
	msgZopeResponse = RegisterWindowMessage("MsgZopeResponse");
	msgZopeStop = RegisterWindowMessage("MsgZopeStop");
	msgZopeStart = RegisterWindowMessage("MsgZopeStart");
	msgZopeQuery = RegisterWindowMessage("MsgZopeQuery");
	msgZopeRegister = RegisterWindowMessage("MsgZopeRegister");
	msgZopeUnregister = RegisterWindowMessage("MsgZopeUnregister");
	
	return CWinApp::InitInstance();
}
