// LogPage.cpp : implementation file
//

#include "stdafx.h"
#include "ControlPanel.h"
#include "LogPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLogPage property page

IMPLEMENT_DYNCREATE(CLogPage, CPropertyPage)

CLogPage::CLogPage() : CPropertyPage(CLogPage::IDD)
{
	
	//{{AFX_DATA_INIT(CLogPage)
	m_LogFile = _T("");
	m_AccessLog = _T("");
	m_StdoutLog = _T("");
	//}}AFX_DATA_INIT
}

CLogPage::~CLogPage()
{
}

void CLogPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLogPage)
	DDX_Control(pDX, IDC_STDOUT_LOG, m_editStdoutLog);
	DDX_Control(pDX, IDC_LOG_FILE, m_editLogFile);
	DDX_Text(pDX, IDC_LOG_FILE, m_LogFile);
	DDX_Text(pDX, IDC_ACCESS_LOG, m_AccessLog);
	DDX_Text(pDX, IDC_STDOUT_LOG, m_StdoutLog);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLogPage, CPropertyPage)
	//{{AFX_MSG_MAP(CLogPage)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_VIEW_STUPIDLOG, OnViewStupidlog)
	ON_BN_CLICKED(IDC_VIEW_ACCESS_LOG, OnViewAccessLog)
	ON_BN_CLICKED(IDC_BROWSE_STDOUT, OnBrowseStdout)
	ON_BN_CLICKED(IDC_VIEW_STDOUT_LOG, OnViewStdoutLog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLogPage message handlers

void CLogPage::OnBrowse() 
{
	CString strCurrent;
	GetDlgItem(IDC_LOG_FILE)->GetWindowText(strCurrent);
	
	CFileDialog dlg(FALSE, "log", strCurrent, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Log Files (*.log)|*.log|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||", this); 
	int nResult = dlg.DoModal();
	
	if (nResult = IDOK)
	{
		m_LogFile = dlg.GetPathName();
		UpdateData(FALSE);
		
		// Enable apply button
		zopeDialog->m_Apply.EnableWindow(TRUE);
	}
}

BOOL CLogPage::OnSetActive() 
{

	ZopeService *currentService = zopeDialog->currentService;

	if (currentService)
	{
		// Retrieve values from ZopeService class
		m_LogFile = currentService->m_StupidLogFile;
		m_StdoutLog = currentService->m_StdOutLogFile;m_AccessLog = CZopeDialog::AddTrailingSlash(currentService->m_ClientHome) + "z2.log";
		m_AccessLog = CZopeDialog::AddTrailingSlash(currentService->m_ClientHome) + "z2.log";
		UpdateData(FALSE);
	}

	return CPropertyPage::OnSetActive();
}

BOOL CLogPage::OnKillActive() 
{
	// Remember information but don't save to registry
	ZopeService *currentService = zopeDialog->currentService;
	
	if (currentService)
	{
		UpdateData(TRUE);
		currentService->m_StupidLogFile = m_LogFile;
		currentService->m_StdOutLogFile = m_StdoutLog;
	}
	
	return CPropertyPage::OnKillActive();
}

void CLogPage::OnViewStupidlog() 
{
	UpdateData(TRUE);
	
	// Check for file existence
	CFileStatus status;
	if (!CFile::GetStatus(m_LogFile, status))
	{
		MessageBox("This log file does not currently exist.", theApp.m_DialogCaption, MB_ICONEXCLAMATION);
		return;
	}

	// Launch notepad (or whatever)
	ShellExecute(m_hWnd, "OPEN", m_LogFile, "", "", SW_SHOW);
	
}

void CLogPage::OnViewAccessLog() 
{
	// Check for file existence
	CFileStatus status;
	if (!CFile::GetStatus(m_AccessLog, status))
	{
		MessageBox("This log file does not currently exist.", theApp.m_DialogCaption, MB_ICONEXCLAMATION);
		return;
	}
	
	// Launch notepad (or whatever)
	ShellExecute(m_hWnd, "OPEN", m_AccessLog, "", "", SW_SHOW);	
}

void CLogPage::OnBrowseStdout() 
{
	CString strCurrent;
	GetDlgItem(IDC_STDOUT_LOG)->GetWindowText(strCurrent);
	
	CFileDialog dlg(FALSE, "log", strCurrent, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Log Files (*.log)|*.log|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||", this); 
	int nResult = dlg.DoModal();
	
	if (nResult = IDOK)
	{
		m_StdoutLog = dlg.GetPathName();
		UpdateData(FALSE);
		
		// Enable apply button
		zopeDialog->m_Apply.EnableWindow(TRUE);
	}
	
}

void CLogPage::OnViewStdoutLog() 
{
	UpdateData(TRUE);

	// Check for file existence
	CFileStatus status;
	if (!CFile::GetStatus(m_StdoutLog, status))
	{
		MessageBox("This log file does not currently exist.", theApp.m_DialogCaption, MB_ICONEXCLAMATION);
		return;
	}

	// Launch notepad (or whatever)
	ShellExecute(m_hWnd, "OPEN", m_StdoutLog, "", "", SW_SHOW);
	
}
