// PasswordDialog.cpp : implementation file
//

#include "stdafx.h"
#include "ControlPanel.h"
#include "PasswordDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPasswordDialog dialog


CPasswordDialog::CPasswordDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CPasswordDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPasswordDialog)
	m_Password1 = _T("");
	m_Password2 = _T("");
	m_Username = _T("");
	//}}AFX_DATA_INIT
}


void CPasswordDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPasswordDialog)
	DDX_Text(pDX, IDC_PASSWORD1, m_Password1);
	DDX_Text(pDX, IDC_PASSWORD2, m_Password2);
	DDX_Text(pDX, IDC_USERNAME, m_Username);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPasswordDialog, CDialog)
	//{{AFX_MSG_MAP(CPasswordDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPasswordDialog message handlers

void CPasswordDialog::OnOK() 
{
	UpdateData(TRUE);
	
	// Validate user data
	if (m_Username.GetLength() == 0
		|| m_Password1.GetLength() == 0)
	{
		MessageBox("You must enter both a username and a password for the emergency user.", theApp.m_DialogCaption, MB_ICONEXCLAMATION);
		return;
	}

	else if (m_Password1 != m_Password2)
	{
		MessageBox("Passwords do not match.  Please enter the same password in both fields to confirm your choice.", theApp.m_DialogCaption, MB_ICONEXCLAMATION);
		return;
	}

	
	CDialog::OnOK();
}

BOOL CPasswordDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_Username = defaultUsername;
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
