// ServicesPage.cpp : implementation file
//

#include "stdafx.h"
#include "ControlPanel.h"
#include "ServicesPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CServicesPage property page

IMPLEMENT_DYNCREATE(CServicesPage, CPropertyPage)

CServicesPage::CServicesPage() : CPropertyPage(CServicesPage::IDD)
{
	//{{AFX_DATA_INIT(CServicesPage)
	m_FTP = _T("");
	m_HTTP = _T("");
	m_HTTPS = _T("");
	m_WEBDAV = _T("");
	m_WEBDAVS = _T("");
	//}}AFX_DATA_INIT
}

CServicesPage::~CServicesPage()
{
}

void CServicesPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServicesPage)
	DDX_Control(pDX, IDC_WEBDAVS, m_editWEBDAVS);
	DDX_Control(pDX, IDC_WEBDAV, m_editWEBDAV);
	DDX_Control(pDX, IDC_HTTPS, m_editHTTPS);
	DDX_Control(pDX, IDC_HTTP, m_editHTTP);
	DDX_Control(pDX, IDC_FTP, m_editFTP);
	DDX_Text(pDX, IDC_FTP, m_FTP);
	DDX_Text(pDX, IDC_HTTP, m_HTTP);
	DDX_Text(pDX, IDC_HTTPS, m_HTTPS);
	DDX_Text(pDX, IDC_WEBDAV, m_WEBDAV);
	DDX_Text(pDX, IDC_WEBDAVS, m_WEBDAVS);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CServicesPage, CPropertyPage)
	//{{AFX_MSG_MAP(CServicesPage)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServicesPage message handlers

BOOL CServicesPage::OnSetActive() 
{
	ZopeService *currentService = zopeDialog->currentService;

	if (currentService)
	{
		// Show ports
		m_HTTP = currentService->http;
		m_HTTPS = currentService->https;
		m_FTP = currentService->ftp;
		m_WEBDAV = currentService->webdav;
		m_WEBDAVS = currentService->webdavs;
		UpdateData(FALSE);	
	}
		
	return CPropertyPage::OnSetActive();
}

BOOL CServicesPage::OnKillActive() 
{
	// Remember information but don't save to registry
	ZopeService *currentService = zopeDialog->currentService;

	if (currentService)
	{
		UpdateData(TRUE);
		strcpy(currentService->http, m_HTTP);
		strcpy(currentService->https, m_HTTPS);
		strcpy(currentService->ftp, m_FTP);
		strcpy(currentService->webdav, m_WEBDAV);
		strcpy(currentService->webdavs, m_WEBDAVS);
	}
	return CPropertyPage::OnKillActive();
}
