#if !defined(AFX_ZOPEDIALOG_H__3A96FAEC_00D7_42AF_8444_87F1DFC864D0__INCLUDED_)
#define AFX_ZOPEDIALOG_H__3A96FAEC_00D7_42AF_8444_87F1DFC864D0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ZopeDialog.h : header file
//
class CZopeDialog;

#include "ServicesPage.h"
#include "LogPage.h"
#include "AboutPage.h"
#include "ExecutionPage.h"
#include "EmergencyUserPage.h"
#include "ControlPage.h"

/////////////////////////////////////////////////////////////////////////////
// CZopeDialog dialog

class CZopeDialog : public CDialog
{

DECLARE_DYNAMIC(CZopeDialog);
	
// Construction
public:
	CZopeDialog(CWnd* pParent = NULL);   // standard constructor

	void DoSetupWizard();
	BOOL m_SetupWizard;		// TRUE if we are in the setup wizard
							// FALSE if running normally

	BOOL m_SingleInstanceMode;	// Triggered by the presence of SingleInstanceMode
								// value in registry

// Destruction
	void Cleanup();

// Attributes
	ZopeService *currentService;

	CPropertySheet *propertySheet;
	CServicesPage *servicesPage;
	CLogPage *logPage;
	CExecutionPage *executionPage;
	CAboutPage *aboutPage;
	CEmergencyUserPage *emergencyUserPage;
	CControlPage *controlPage;

	CString m_GlobalSoftwareHome;
	CString m_GlobalStartupScript;
	CString m_GlobalPythonHome;
	CString m_GlobalInterpreter;
	CString m_DefaultInstanceDir;

	SC_HANDLE schSCManager;
	BOOL m_ServiceManagerAvailable;
	BOOL m_UseNTServiceDaemon;
	CString m_DaemonNTPath;
	CString m_Daemon95Path;

	void ShowHelpTab();
	void ShowAllTabs();
	void ApplyChanges();

	BOOL ServiceExists(CString name);

	static CString GetSetting(HKEY key, LPCSTR value, CString defaultSetting);
	static void AddTrailingSlash(CString *path);
	static CString AddTrailingSlash(CString path);

// Dialog Data
	//{{AFX_DATA(CZopeDialog)
	enum { IDD = IDD_ZOPE };
	CButton	m_Apply;
	CButton	m_ConfigurationDelete;
	CComboBox	m_ConfigurationList;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CZopeDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CZopeDialog)
	afx_msg void OnConfigurationAdd();
	afx_msg void OnConfigurationDelete();
	afx_msg void OnSelchangeConfigurationList();
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnDestroy();
	afx_msg void OnAdvanced();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.


#endif // !defined(AFX_ZOPEDIALOG_H__3A96FAEC_00D7_42AF_8444_87F1DFC864D0__INCLUDED_)
